player = {}

function player.load()
  player.clr = {207, 129, 48}

  obj.player = {}

  player.onScreenX = W/5
  player.size = H/16

  obj.player.body = love.physics.newBody(pWorld, W/5, H/2, "dynamic")
  obj.player.body:setLinearDamping(0)
  obj.player.shape = love.physics.newRectangleShape(player.size, player.size)
  obj.player.fixture = love.physics.newFixture(obj.player.body, obj.player.shape, 1)
  obj.player.fixture:setRestitution(0.1)
  obj.player.fixture:setFriction(0.9)
end

function player.update(dt)
  player.contacts = obj.player.body:getContactList()

  -- Keeping the x position of the player in the same place
  player.drawPoints = {obj.player.body:getWorldPoints(obj.player.shape:getPoints())}
  for n = 1, 7, 2 do
    player.drawPoints[n] = player.drawPoints[n] - obj.player.body:getX() + player.onScreenX
  end

  -- Death
  if obj.player.body:getY() > H then
    ui.score = 0

    obj.player.body:setPosition(W/5, 0)
    obj.player.body:setLinearVelocity(0, 0)
    obj.player.body:setAngularVelocity(0)

    obj.platform[1].body:destroy()
    obj.platform[1].w = obj.platform.width
    obj.platform[1].h = H
    obj.platform[1].body = love.physics.newBody(pWorld, W/5, H)
    obj.platform[1].shape = love.physics.newRectangleShape(obj.platform.width, H)
    obj.platform[1].fixture = love.physics.newFixture(obj.platform[1].body, obj.platform[1].shape)

    obj.platform[2].body:destroy()
    obj.platform[2].w = obj.platform.width
    obj.platform[2].h = H
    obj.platform[2].body = love.physics.newBody(pWorld, W - W/5, obj.platform.getRandomY(1, H))
    obj.platform[2].shape = love.physics.newRectangleShape(obj.platform.width, H)
    obj.platform[2].fixture = love.physics.newFixture(obj.platform[2].body, obj.platform[2].shape)

    for n = 1, 2, 1 do
      obj.platform[n].fixture = love.physics.newFixture(obj.platform[n].body, obj.platform[n].shape)
      obj.platform[n].short = false
      obj.platform[n].slippery = false
      obj.platform[n].timed = false
    end

    world.currentPlatform = obj.platform[1].fixture
  end

  function player.mousereleased(x, y, mb, istouch)
    --if obj.player.body:isTouching(obj.platform[1].body) or obj.player.body:isTouching(obj.platform[2].body) then
      obj.player.body:setLinearVelocity((player.onScreenX-x)*ui.pullStrength, (obj.player.body:getY()-y)*ui.pullStrength)
      --obj.player.body:setAngularVelocity(love.math.random(-15, 15)/10)
    --end
  end
end

function player.draw()
  love.graphics.setColor(player.clr)
  love.graphics.setColor(83, 249, 56)
  love.graphics.polygon("fill", player.drawPoints)
end
