ui = {}

function ui.load()
  ui.defaultFont = love.graphics.newFont('font/consola.ttf', H/50)

  ui.pullStrength = 7
  ui.score = 1

  ui.info = true
  ui.infoStr = {}
	ui.infoStr['left'] = ''
	ui.infoStr['center'] = ''
	ui.infoStr['right'] = ''

	function ui.addInfo(str, pos)
		if pos == nil then
			pos = 'left'
		end
		if str == nil then
			str = '\n'
		end

		ui.infoStr[pos] = ui.infoStr[pos]..str..'\n'
	end
end

function ui.update(dt)
  if ui.info then
		ui.infoStr['left'] = ''
		ui.infoStr['center'] = ''
		ui.infoStr['right'] = ''

		-- Add debug info here
		ui.addInfo(love.timer.getFPS()..' fps', 'right')
    ui.addInfo(opSys, 'right')

		ui.addInfo(gamestate)
		ui.addInfo('[plyr] '..math.floor(obj.player.body:getX())..'; '..math.floor(obj.player.body:getY())..' ('..math.floor(obj.player.body:getY()+player.size/2)..')')
		ui.addInfo('[mous] '..love.mouse.getX()..'; '..love.mouse.getY())

    ui.addInfo(ui.score, 'center')
	end

  function ui.func(key)
    if key == 'f1' then
      ui.info = not ui.info
    end
  end

  function ui.keypressed(key)
		ui.func(key)
	end
end

function ui.drawBackground()
  love.graphics.setColor(230, 100, 60)
  love.graphics.setLineWidth(H*0.006)
  love.graphics.setPointSize(H*0.006)
  if love.mouse.isDown(1) then
    love.graphics.line(player.onScreenX, obj.player.body:getY(), love.mouse.getX(), love.mouse.getY())
    -- Per second approach
    for n = .01, .8, .02 do
      love.graphics.setColor(230, 100, 60, 255-255*n/.8)
      love.graphics.line(player.onScreenX+(player.onScreenX-love.mouse.getX())*ui.pullStrength*n,
      obj.player.body:getY()+(obj.player.body:getY()-love.mouse.getY())*ui.pullStrength*n+(world.g*world.meter*n^2)/2,
      player.onScreenX+(player.onScreenX-love.mouse.getX())*ui.pullStrength*(n+.01),
      obj.player.body:getY()+(obj.player.body:getY()-love.mouse.getY())*ui.pullStrength*(n+.01)+(world.g*world.meter*(n+.01)^2)/2)
    end
    -- Per timestep approach
    love.graphics.setColor(51, 244, 88)
    for n = 1, 60, 1 do
      love.graphics.points(player.onScreenX + (player.onScreenX-love.mouse.getX())*ui.pullStrength*n/60,
      obj.player.body:getY() + (obj.player.body:getY()-love.mouse.getY())*ui.pullStrength*n/60 + (n*n+n)*(world.g*world.meter)/(60*60)/2)
    end
  end
end

function ui.draw()
  if ui.info then
		love.graphics.setFont(ui.defaultFont)
		for n = 0, 1, 1 do
			love.graphics.setColor(255*n, 255*n, 255*n)
			for pos in pairs(ui.infoStr) do
				love.graphics.printf(ui.infoStr[pos], 10-n, 10-n, W-20, pos)
			end
      for f = 1, 2, 1 do
        love.graphics.printf(obj.platform[f].body:getY()-H/2, obj.platform[f].body:getX()-obj.player.body:getX()+player.onScreenX-obj.platform.width/2,
        obj.platform[f].body:getY()-obj.platform[f].h/2, obj.platform[f].w, 'left')
        love.graphics.printf('Slp='..tostring(obj.platform[f].slippery), obj.platform[f].body:getX()-obj.player.body:getX()+player.onScreenX-obj.platform.width/2,
        obj.platform[f].body:getY()-obj.platform[f].h/2, obj.platform[f].w, 'right')
        love.graphics.printf('Tim='..tostring(obj.platform[f].timed), obj.platform[f].body:getX()-obj.player.body:getX()+player.onScreenX-obj.platform.width/2,
        obj.platform[f].body:getY()-obj.platform[f].h/2+H/50, obj.platform[f].w, 'right')
        love.graphics.printf('Shr='..tostring(obj.platform[f].short), obj.platform[f].body:getX()-obj.player.body:getX()+player.onScreenX-obj.platform.width/2,
        obj.platform[f].body:getY()-obj.platform[f].h/2+H/25, obj.platform[f].w, 'right')
      end
		end
	end
end
